# Solver Documentation

Documentation for the `SARSOP.jl` user interface.

```@meta
CurrentModule = SARSOP
```

## Contents

```@contents
Pages = ["api.md"]
```

## Index

```@index
Pages = ["api.md"]
```

## Solver

```@docs
SARSOPSolver
```

## File manipulation

```@docs
POMDPFile
to_pomdpx
load_policy
```

## Simulation and Evaluation

```@docs 
SARSOPSimulator
simulate
SARSOPEvaluator
evaluate
```

## Policy Graph Generation 

```@docs
PolicyGraphGenerator
generate_graph
```
